
.TH NEWSCAN 1 "June 3, 1993"
.AT 3
.SH NAME
newscan \- scans Usenet news for articles matching regular expressions 
(uses perl regular expressions).  Articles are saved in a mail folder, 
a file in mailbox format.

.SH SYNOPSIS
.B newscan [-c configuration-file] [-e] [-r folder-file-specification] 
[-H name-of-local-host][-h] [-s]
.SH DESCRIPTION
.I newscan
searches selected newsgroups for articles matching patterns.  Patterns are 
specified as regular expressions in a configuration or resource file.  Also 
may specify patterns to veto articles.  If an article contains this 
pattern, the article will be ignored even if it contains a search pattern.
The configuration file is specified with the command line argument 
-c configuration-file or in the environment variable NEWSCAN.  The command 
line argument takes precedence over the NEWSCAN environment variable. If 
NEWSCAN is undefined, the configuration file defaults to .newscanrc in the 
user's home directory.

Typically, newscan is run as a batch job: 
	newscan -s &      ( -s to turn off in progress messages )
OR
	newscan > newscan.out &  ( redirect in progress messages to file )

.SH OPTIONS

	What You Want To Do		Option

	Get help on
.I newscan				-h

	Edit Configuration File		-e

	Override Default Configuration File	-c configuration-file

	Invoke Mail Reader to Read a Folder	-r folder

        Explicitly Set Local Host Name          -H name-of-local-host

	Silent Mode (Suppress In Progress Messages)  -s


.SH CONFIGURATION FILE
newscan is controlled by a resource or configuration file containing 
command in a simple language that newscan understands.  These commands 
should be all capitals.

Configuration file commands:

NNTP them.them.com [119] specifies the Internet address of the NNTP
server.  The first argument is the Internet address either as a Fully
Qualified Domain Name or the dotted decimal format for the 32 bit Internet
address.  The optional second argument is the port number of the NNTP
server; this should be 119 if NNTP specification is followed.  Port
119 is reserved for NNTP.

    If this line is not specified, newscan will use the environment
variable NNTPSERVER if it is defined.  If NNTPSERVER is not defined, newscan
will use the local machine as default NNTP server.  The local machine is
frequently not an NNTP server.

MBOX <my-file-specification> specifies the file where the found
articles are stored.  This file is a mail folder that may be
read and manipulated by any mailer (Mail User Agent)
<my-file-specification> can be any valid Unix
file-specification (including path).  MBOX interprets a leading tilde
~ as the user's home directory: e.g.  MBOX ~/tmp/myfile.

SELECT my.group his.group alt.group specifies the Internet newsgroups
for which subsequent search specifications apply.  newscan searches all
newsgroups specified by SELECT lines. 

SELECT supports a wildcard * in newsgroups.  The wildcard works like
the wildcard in file names in Unix shells. For example, SELECT
comp.lang.* will search all groups in the comp.lang hierarchy:
comp.lang.fortran, comp.lang.forth, ..., comp.lang.pascal, etc.

REQUIRE /regexp/[i] specifies a perl regular expression that MUST be
found for a match to occur.  This search criterion applies only to
the newsgroups specified by the last preceding SELECT line.  

REQUIRE provides a mechanism to search for articles that contain a
match to more than one search pattern.  For example, REQUIRE /pat1/i
and REQUIRE /pat2/i will find articles that contain pat1 AND pat2; it
will not find an article that has pat1 but NOT pat2 or pat2 but NOT
pat1.  REQUIRE provides a simple mechanism to perform a logical AND of
two search patterns.

WHERE /regexp/[i] specifies the perl regular expression to be found.
As in perl, the optional trailing /i tells newscan to ignore case.  This
search criterion applies only to the newsgroups specified by the 
last preceding SELECT line.

WHERE provides a mechanism to search for articles that contain a match
to one or more of a group of search patterns.  For example, WHERE /pat1/i
and WHERE /pat2/i will find articles that contain pat1 OR pat2 OR both.
Notice the contrast to REQUIRE above!

UNLESS /regexp/[i] specifies the perl regular expression used to
exclude an article.  Even if the article contains a match to a WHERE
regular expression it will be excluded (not found) if it contains a
match to an UNLESS expression.  As in perl, the optional trailing /i
tells newscan to ignore case.

WORD blatz is equivalent to /\\bblatz\\b/i A configuration file can
contain lines such as WHERE WORD vision or REQUIRE WORD finance.
WHERE WORD vision matches the word vision.  WHERE WORD vision would
not match computer-vision since vision is not a word in this case.
This provides a somewhat simpler way to specify searches without
knowing Perl regular expressions.

WORDSTEM blatz is equivalent to /\\bblatz.*\\b/i  A configuration file
can contain lines such as WHERE WORDSTEM imag or REQUIRE WORDSTEM imag.
WHERE WORDSTEM imag would match words image, imaging, imager, and so forth.
This provides a somewhat simpler way to specify searches without knowing
Perl regular expressions.

PHRASE word1 word2 [... wordn] is equivalent to
/\\bword1\\b\\s+\\bword2\\b/i A configuration file can contain lines
such as WHERE PHRASE tcl programming or REQUIRE PHRASE tcl
programming.  This provides a somewhat simpler way to specify searches
without knowing Perl regular expressions.

OUTLINE word1 word2 [... wordn] is equivalent to
/\\bword1\\b.*\\bword2\\b/i A configuration file can contain lines
such as WHERE OUTLINE software engineer or REQUIRE OUTLINE windows
engineer.  OUTLINE windows engineer would match ms windows engineer,
windows software engineer, as well as windows engineer.  Note that
this is different from PHRASE windows engineer which would only match
windows engineer!  This provides a somewhat simpler way to specify
searches without knowing Perl regular expressions.

COLLECT STATISTICS IN <file-specification> line tells newscan to collect
statistics on the incidence of regular expressions in all articles scanned 
(not just articles that match).  These statistics are printed in human
readable form in the file <file-specification>.  newscan appends the
statistics information to <file-specification>.

COLLECT STATISTICS ON /regexp/[i] line tells newscan to collect statisitcs on
incidence of perl regular expression regexp.  newscan counts the number of
articles that contain at least one match to regexp.

COLLECT STATISTICS ON {SEARCH|WHERE} PATTERNS tells newscan to collect
statistics on all perl regular expressions specified by WHERE /regexp/[i]
lines in the configuration file.

COLLECT STATISTICS ON {VETO|UNLESS} PATTERNS tells newscan to collect
statistics on all perl regular expressions specified by UNLESS /regexp/[i]
lines in the configuration file.

COLLECT STATISTICS ON PAIRS tells newscan to collect statistics on all pairs
of perl regular expressions for which statistics are being collected.  newscan
counts the number of articles containing at least one match to both regular
expressions.  newscan also calculates a simple correlation coefficient between
the two regular expressions in the pair.  Note that if the correlation 
coefficient is 1.0, then the two regular expressions always occur together;
this means one regular expression is a redundant (unneeded) search criterion. 

my.favorite.group:1-1100,1105-1110 is a line in the configuration file
that lists ranges of articles in a group that are excluded from
search.  newscan updates this range after it finishes to avoid
repeating a search.  If this line is not provided by the user, newscan
will generate the group range line and append it to the end of the
configuration file.  newscan generates the group range line for any
other groups that a found article has been posted to.

.SH SAMPLE RESOURCE FILE

NNTP nntphost 

MBOX myBox

SELECT misc.jobs.offered ba.jobs.offered

WHERE /gui/i

WHERE /motif/i

WHERE /graphic/i

UNLESS /From:.*Headhunter/i

UNLESS /Subject:.*Recruit/i

misc.jobs.offered:1-1000

ba.jobs.offered:

.SH ENVIRONMENT 
.I NEWSCAN 
environment variable defines the configuration or resource file that
controls the search.  If NEWSCAN is not defined, then newscan defaults
to the file .newscanrc in the user's home directory.  NEWSCAN is
superseded by the -c configuration-file command line argument.

.I NNTPSERVER
environment variable specifies the Internet address of the system NNTP
server.  The NNTP <nntphost> line in the configuration file takes
precedence over the NNTPSERVER variable.

.I READER
environment variable selects the mail reader used by newscan.  If READER
is not set, newscan will try to find and use a mail reader of its choosing.
newscan will use Dave Taylor's elm if it exists.

.I EDITOR
environment variable selects the editor used by newscan.  If EDITOR is not
set, newscan will try to use first emacs and then vi.

.I LOCALHOST
environment variable explicitly sets the name of the local host.  newscan
defaults to using the Unix 
.B
hostname
utility to get the local host name.  In most cases, there is no need to
set LOCALHOST.  However, at least on Linux, if the local host's official
name returned by hostname is a number such as 440, the 
.B
gethostbyname
function called by newscan will not return the correct Internet address.  
In this case, set LOCALHOST to a valid alias of the official name that is
not a number.  For example, 440 might have an alias 440.rahul.net.  Use
440.rahul.net.

.SH FILES 
.I $HOME/.newscanrc 
is the default resource or configuration file
specifying the search.  This can be overridden from the command line
(using -c configuration-file) or by setting the NEWSCAN environment
variable.  The command line argument supersedes the NEWSCAN
environment variable.

.I newscanBox
is the default file where newscan saves found articles in mailbox
format.  This can be overridden by using the MBOX file-name command in
the configuration file.

.SH PERL REGULAR EXPRESSIONS

newscan uses Perl regular expressions to specify the patterns that it searches
for in the selected newsgroups.  Perl regular expressions are similar to
the regular expressions used in sed, vi, and emacs, but more extensive.

    .           Matches any character except for newline
    [a-z0-9]    Matches any single character of a set
    [^a-z0-9]   Matches any signle character not in set
    \\d          Matches a digit, same as [0-9]
    \\D	        Matches a non-digit, same as [^0-9]
    \\w          Matches an alphanumeric (word) character [a-zA-Z0-9_]
    \\W          Matches a non-word character [^a-zA-Z0-9_]
    \\s          Matches a whitespace character (space, tab, newline...)
    \\S          Matches a non-whitespace character

    \\n          Matches a newline
    \\r          Matches a return
    \\t          Matches a horizontal tab
    \\f          Matches a formfeed
    \\b          Matches a backspace ( inside [] only! )
    \\0          Matches a null character
    \\000        Also matches a null character
    \\nnn        Matches an ASCII character of that octal value
    \\xnn        Matches an ASCII character of that hexadecimal value
    \\cX         Matches an ASCII control character
    \\metachar   Matches the character itself (\|, \., etc.)

    (abc)	 Remembers the match for later backreferences
    \\1		 Matches whatever first set of parens matched
    \\2          Matches whatever second set of parens matched
    \\3          Matches whatever third set of parens match ... and so on

    x?           Matches 0 or 1 x's, where x is any of above
    x*           Matches 0 or more x's
    x+           Matches 1 or more x's
    x{m,n}       Matches at least m x's but no more than n

    abc          Matches abc in order
    fee|fie|foe  Matches one of fee, fie, or foe
    
    \\b		 Matches a word boundary (outside [] only!)
    \\B          Matches a non-word boundary
    ^            Anchors match to the beginning of a line or string
    $		 Anchors match to the end of line or string
    
.SH EXAMPLES OF PERL REGULAR EXPRESSIONS 

.I 
WHERE /\\bphigs\\b/i 

Search for the word PHIGS (case insensitive) Uses \\b word boundary
symbol.  Note that this search would NOT find a news article
containing the word "SunPHIGS"

.I 
WHERE /phigs/i

Search for the string PHIGS (case insensitive) Does not use \\b.  Note
that this search would find a news article containing the word
"SunPHIGS".

.I 
WHERE /John\\s+Smith/        

Search for the string John (any number of spaces) Smith.  Case
sensitive.  Would not find "john smith".  Would find "John Smith".

.I 
WHERE /^Subject:.*phigs/i   

Search for a news article whose Subject contains the string phigs.

.I 
UNLESS /^From:.*Mad\\s+Flamer/i  

Ignore articles from Mad Flamer!


.SH SEE ALSO

"Programming Perl" by Larry Wall and Randal L. Schwartz, published by
O'Reilly and Associates (ISBN: 0-937175-64-1).  Often referred to as the
"Camel" book after the Camel on the cover.  A comprehensive book on Perl.

"Learning Perl" by Randal L. Schwartz, published by O'Reilly and Associates
(ISBN: 1-56592-042-2).  Often referred to as the "Llama" book after the Llama
on the cover.  Introductory Perl book.

comp.lang.perl USENET newsgroup.

Perl Frequently Asked Questions (FAQ) document.

.SH AUTHOR
.I John F. McGowan, Ph.D.

e-mail: jfm@jupiter.slac.stanford.edu (or) jfm@rahul.net

.SH DIAGNOSTICS

.SH BUGS
A known nuisance is that newscan will find the same article more than once if 
the article has been manually posted to more than one newsgroup that newscan 
searches.  If the article has been properly cross-posted to multiple
newsgroups, newscan will find only one copy of the article.

A number of people have reported problems running newscan under Perl 5.000
There appears to be a memory leak under Perl 5.000; During some long searches
newscan will run out of memory and quit.  I strongly recommend using perl 
4.036 to run newscan.

Please report any bugs to the author.

.SH COPYRIGHTS
(C) Copyright 1993, 1994, 1995 by John F. McGowan, Ph.D. 

You may use or modify newscan as you like.  However, you must credit
John McGowan as the author of the original version of newscan and
include the copyright notice above.

.SH DISCLAIMER
.I newscan 
is provided 
.I as is.  
There is no warranty, express or implied, that it will do what you want.  
There is no warranty that it will work reliably or without error.  The 
author disclaims all responsibility or liability for any consequences of 
using newscan, including but not limited to losses of time or money.  

In other words, use at your own risk.    







#line 3201 "y.tab.pl"
